## Pointer Arrays Pointer Arrays — arrays of pointers to any type of data, which grow automatically as new elements are added |

## Functions

GPtrArray * | g_ptr_array_new ()
GPtrArray * | g_ptr_array_sized_new ()
GPtrArray * | g_ptr_array_new_with_free_func ()
GPtrArray * | g_ptr_array_new_full ()
void | g_ptr_array_set_free_func ()
GPtrArray * | g_ptr_array_ref ()
void | g_ptr_array_unref ()
void | g_ptr_array_add ()
void | g_ptr_array_insert ()
gboolean | g_ptr_array_remove ()
gpointer | g_ptr_array_remove_index ()
gboolean | g_ptr_array_remove_fast ()
gpointer | g_ptr_array_remove_index_fast ()
GPtrArray * | g_ptr_array_remove_range ()
void | g_ptr_array_sort ()
void | g_ptr_array_sort_with_data ()
void | g_ptr_array_set_size ()
#define | g_ptr_array_index()
gpointer * | g_ptr_array_free ()
void | g_ptr_array_foreach ()

## Types and Values

struct | GPtrArray

## Includes

    #include <glib.h>

## Description

Pointer Arrays are similar to Arrays but are used only for storing pointers.

If you remove elements from the array, elements at the end of the array are moved into the space previously occupied by the removed element. This means that you should not rely on the index of particular elements remaining the same. You should also be careful when deleting elements while iterating over the array.

To create a pointer array, use `g_ptr_array_new()`.

To add elements to a pointer array, use `g_ptr_array_add()`.

To remove elements from a pointer array, use `g_ptr_array_remove()`, `g_ptr_array_remove_index()` or `g_ptr_array_remove_index_fast()`.

To access an element of a pointer array, use `g_ptr_array_index()`.

To set the size of a pointer array, use `g_ptr_array_set_size()`.

To free a pointer array, use `g_ptr_array_free()`.

An example using a GPtrArray:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    GPtrArray *array;
    gchar *string1 = "one";
    gchar *string2 = "two";
    gchar *string3 = "three";

    array = g_ptr_array_new ();
    g_ptr_array_add (array, (gpointer) string1);
    g_ptr_array_add (array, (gpointer) string2);
    g_ptr_array_add (array, (gpointer) string3);

    if (g_ptr_array_index (array, 0) != (gpointer) string1)
      g_print ("ERROR: got %p instead of %p\n",
               g_ptr_array_index (array, 0), string1);

    g_ptr_array_free (array, TRUE);

## Functions

### g_ptr_array_new ()

    GPtrArray *
    g_ptr_array_new (void);

Creates a new GPtrArray with a reference count of 1.

#### Returns

the new GPtrArray

### g_ptr_array_sized_new ()

    GPtrArray *
    g_ptr_array_sized_new (guint reserved_size);

Creates a new GPtrArray with `reserved_size` pointers preallocated and a reference count of 1. This avoids frequent reallocation, if you are going to add many pointers to the array. Note however that the size of the array is still 0.

#### Parameters

reserved_size | number of pointers preallocated |

#### Returns

the new GPtrArray

### g_ptr_array_new_with_free_func ()

    GPtrArray *
    g_ptr_array_new_with_free_func (GDestroyNotify element_free_func);

Creates a new GPtrArray with a reference count of 1 and use `element_free_func` for freeing each element when the array is destroyed either via `g_ptr_array_unref()`, when `g_ptr_array_free()` is called with `free_segment` set to `TRUE` or when removing elements.

#### Parameters

element_free_func | A function to free elements with destroy `array` or `NULL`. | [nullable]

#### Returns

A new GPtrArray

Since: 2.22

### g_ptr_array_new_full ()

    GPtrArray *
    g_ptr_array_new_full (guint reserved_size,
                          GDestroyNotify element_free_func);

Creates a new GPtrArray with `reserved_size` pointers preallocated and a reference count of 1. This avoids frequent reallocation, if you are going to add many pointers to the array. Note however that the size of the array is still 0. It also set `element_free_func` for freeing each element when the array is destroyed either via `g_ptr_array_unref()`, when `g_ptr_array_free()` is called with `free_segment` set to `TRUE` or when removing elements.

#### Parameters

reserved_size | number of pointers preallocated |
element_free_func | A function to free elements with destroy `array` or `NULL`. | [nullable]

#### Returns

A new GPtrArray

Since: 2.30

### g_ptr_array_set_free_func ()

    void
    g_ptr_array_set_free_func (GPtrArray *array,
                               GDestroyNotify element_free_func);

Sets a function for freeing each element when `array` is destroyed either via `g_ptr_array_unref()`, when `g_ptr_array_free()` is called with `free_segment` set to `TRUE` or when removing elements.

#### Parameters

array | A GPtrArray |
element_free_func | A function to free elements with destroy `array` or `NULL`. | [nullable]

Since: 2.22

### g_ptr_array_ref ()

    GPtrArray *
    g_ptr_array_ref (GPtrArray *array);

Atomically increments the reference count of `array` by one. This function is thread-safe and may be called from any thread.

#### Parameters

array | a GPtrArray |

#### Returns

The passed in GPtrArray

Since: 2.22

### g_ptr_array_unref ()

    void
    g_ptr_array_unref (GPtrArray *array);

Atomically decrements the reference count of `array` by one. If the reference count drops to 0, the effect is the same as calling `g_ptr_array_free()` with `free_segment` set to `TRUE`. This function is MT-safe and may be called from any thread.

#### Parameters

array | A GPtrArray |

Since: 2.22

### g_ptr_array_add ()

    void
    g_ptr_array_add (GPtrArray *array,
                     gpointer data);

Adds a pointer to the end of the pointer array. The array will grow in size automatically if necessary.

#### Parameters

array | a GPtrArray |
data | the pointer to add |

### g_ptr_array_insert ()

    void
    g_ptr_array_insert (GPtrArray *array,
                        gint index_,
                        gpointer data);

Inserts an element into the pointer array at the given index. The array will grow in size automatically if necessary.

#### Parameters

array | a GPtrArray |
index_ | the index to place the new element at, or -1 to append |
data | the pointer to add. |

Since: 2.40

### g_ptr_array_remove ()

    gboolean
    g_ptr_array_remove (GPtrArray *array,
                        gpointer data);

Removes the first occurrence of the given pointer from the pointer array. The following elements are moved down one place. If `array` has a non-`NULL` GDestroyNotify function it is called for the removed element.

It returns `TRUE` if the pointer was removed, or `FALSE` if the pointer was not found.

#### Parameters

array | a GPtrArray |
data | the pointer to remove |

#### Returns

`TRUE` if the pointer is removed, `FALSE` if the pointer is not found in the array

### g_ptr_array_remove_index ()

    gpointer
    g_ptr_array_remove_index (GPtrArray *array,
                              guint index_);

Removes the pointer at the given index from the pointer array. The following elements are moved down one place. If `array` has a non-`NULL` GDestroyNotify function it is called for the removed element.

#### Parameters

array | a GPtrArray |
index_ | the index of the pointer to remove |

#### Returns

the pointer which was removed

### g_ptr_array_remove_fast ()

    gboolean
    g_ptr_array_remove_fast (GPtrArray *array,
                             gpointer data);

Removes the first occurrence of the given pointer from the pointer array. The last element in the array is used to fill in the space, so this function does not preserve the order of the array. But it is faster than `g_ptr_array_remove()`. If `array` has a non-`NULL` GDestroyNotify function it is called for the removed element.

It returns `TRUE` if the pointer was removed, or `FALSE` if the pointer was not found.

#### Parameters

array | a GPtrArray |
data | the pointer to remove |

#### Returns

`TRUE` if the pointer was found in the array

### g_ptr_array_remove_index_fast ()

    gpointer
    g_ptr_array_remove_index_fast (GPtrArray *array,
                                   guint index_);

Removes the pointer at the given index from the pointer array. The last element in the array is used to fill in the space, so this function does not preserve the order of the array. But it is faster than `g_ptr_array_remove_index()`. If `array` has a non-`NULL` GDestroyNotify function it is called for the removed element.

#### Parameters

array | a GPtrArray |
index_ | the index of the pointer to remove |

#### Returns

the pointer which was removed

### g_ptr_array_remove_range ()

    GPtrArray *
    g_ptr_array_remove_range (GPtrArray *array,
                              guint index_,
                              guint length);

Removes the given number of pointers starting at the given index from a GPtrArray. The following elements are moved to close the gap. If `array` has a non-`NULL` GDestroyNotify function it is called for the removed elements.

#### Parameters

array | a `GPtrArray` |
index_ | the index of the first pointer to remove |
length | the number of pointers to remove |

#### Returns

the `array`

Since: 2.4

### g_ptr_array_sort ()

    void
    g_ptr_array_sort (GPtrArray *array,
                      GCompareFunc compare_func);

Sorts the array, using `compare_func` which should be a `qsort()`-style comparison function (returns less than zero for first arg is less than second arg, zero for equal, greater than zero if irst arg is greater than second arg).

Note that the comparison function for `g_ptr_array_sort()` doesn't take the pointers from the array as arguments, it takes pointers to the pointers in the array.

This is guaranteed to be a stable sort since version 2.32.

#### Parameters

array | a GPtrArray |
compare_func | comparison function |

### g_ptr_array_sort_with_data ()

    void
    g_ptr_array_sort_with_data (GPtrArray *array,
                                GCompareDataFunc compare_func,
                                gpointer user_data);

Like `g_ptr_array_sort()`, but the comparison function has an extra user data argument.

Note that the comparison function for `g_ptr_array_sort_with_data()` doesn't take the pointers from the array as arguments, it takes pointers to the pointers in the array.

This is guaranteed to be a stable sort since version 2.32.

#### Parameters

array | a GPtrArray |
compare_func | comparison function |
user_data | data to pass to `compare_func` |

### g_ptr_array_set_size ()

    void
    g_ptr_array_set_size (GPtrArray *array,
                          gint length);

Sets the size of the array. When making the array larger, newly-added elements will be set to `NULL`. When making it smaller, if `array` has a non-`NULL` GDestroyNotify function then it will be called for the removed elements.

#### Parameters

array | a GPtrArray |
length | the new length of the pointer array |

### g_ptr_array_index()

    #define             g_ptr_array_index(array,index_)

Returns the pointer at the given index of the pointer array.

This does not perform bounds checking on the given `index_` , so you are responsible for checking it against the array length.

#### Parameters

array | a GPtrArray |
index_ | the index of the pointer to return |

#### Returns

the pointer at the given index

### g_ptr_array_free ()

    gpointer *
    g_ptr_array_free (GPtrArray *array,
                      gboolean free_seg);

Frees the memory allocated for the GPtrArray. If `free_seg` is `TRUE` it frees the memory block holding the elements as well. Pass `FALSE` if you want to free the GPtrArray wrapper but preserve the underlying array for use elsewhere. If the reference count of `array` is greater than one, the GPtrArray wrapper is preserved but the size of `array` will be set to zero.

If array contents point to dynamically-allocated memory, they should be freed separately if `free_seg` is `TRUE` and no GDestroyNotify function has been set for `array` .

#### Parameters

array | a GPtrArray |
free_seg | if `TRUE` the actual pointer array is freed as well |

#### Returns

the pointer array if `free_seg` is `FALSE`, otherwise `NULL`. The pointer array should be freed using `g_free()`.

### g_ptr_array_foreach ()

    void
    g_ptr_array_foreach (GPtrArray *array,
                         GFunc func,
                         gpointer user_data);

Calls a function for each element of a GPtrArray.

#### Parameters

array | a GPtrArray |
func | the function to call for each array element |
user_data | user data to pass to the function |

Since: 2.4

## Types and Values

### struct GPtrArray

    struct GPtrArray {
      gpointer *pdata;
      guint	    len;
    };

Contains the public fields of a pointer array.

#### Members

gpointer *`pdata`; | points to the array of pointers, which may be moved when the array grows |
guint `len`; | number of pointers in the array |